import java.util.*;

interface myCollection<T> {
	void add(T t);
	boolean isMember(T t);
}

interface myPQ<T extends Comparable<T>> extends myCollection<T> {
	T getFirst();
}

class myPQArrayS<T extends Comparable<T>> implements myPQ<T> {
	List<T> data;
	public myPQArrayS(){ data = new ArrayList<>(); }
	public void add(T t){ data.add(t); }
	public boolean isMember(T t){
		for(int i =0; i<data.size(); i++)
			if(data.get(i).equals(t)) return true;
		return false;
	}
	public T getFirst(){
		int sol=0;
		for(int i=1; i<data.size(); i++) if(data.get(sol).compareTo(data.get(i))<0) sol = i;
		T tmp = data.get(sol);
		data.remove(sol);
		return tmp;
	}
	public String toString(){
		return data.toString();
	}
}

class myPQArray<T extends Comparable<T>> implements myPQ<T> {
	List<T> data;
	public myPQArray(){ data = new ArrayList<>(); }
	public void add(T t){
		data.add(t);
		//re-order!!
		int i = data.size()-1;
		while(i>0){
			if(data.get((i-1)/2).compareTo(data.get(i)) < 0){
				T tmp = data.get(i);
				data.set(i,data.get((i-1)/2));
				data.set((i-1)/2,tmp);
				i = (i-1)/2;
			}else break;
		}
	}
	public boolean isMember(T t){
		for(int i =0; i<data.size(); i++)
			if(data.get(i).equals(t)) return true;
		return false;
	}
	public T getFirst(){
		T tmp = data.get(0);
		data.set(0,data.get(data.size()-1));
		data.remove(data.size()-1);
		for(int i=0; 2*i+1<data.size(); ){
			int max;
			max = 2*i+1;
			if(2*i+2<data.size())
				if(data.get(max).compareTo(data.get(2*i+2))<0) max = 2*i+2; 
			if(data.get(i).compareTo(data.get(max))<0){
				T tmp2 = data.get(max);
				data.set(max,data.get(i));
				data.set(i,tmp2);
				i=max;
			}else break;
		}
		return tmp;
	}
	public String toString(){
		return data.toString();
	}
	public static void main(String [] args){
		Scanner s = new Scanner(System.in);
		myPQ<Integer> pq = new myPQArrayS<>();
		while(s.hasNext()){
			if(s.hasNextInt())
				pq.add(s.nextInt());
			else{
				s.next();
				System.out.println("Top element: "+pq.getFirst());
			}
			System.out.println("Current state: "+pq);
		}
		for(int i=0; i<100000; i++) pq.add(i);
		System.out.println("Added!");
		for(int i=0; i<100000; i++) pq.getFirst();
		System.out.println("Removed!");
		
	}
}
